/*############################################################
 uXPg_CAOv ver1.0              @  (2001/01/25)

                                (E-mail : beefway@anet.ne.jp)
############################################################*/

/*////////////////////////////////////////////////////////////

 main.c t@C

////////////////////////////////////////////////////////////*/


#define   VERSION       "ver1.0"
char strtmp[10000];                   // eXgp

#define   THISNAME       "XPg_CAO"
#define   COPYRIGHT      "Copyright (C) 1999-2001 Beefway Tools."
#include <windows.h>
#include <winuser.h>
#include <commctrl.h>
#include <io.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <math.h>
#include "resource.h"
#include "main.h"
#include "user.h"
#include "init.c"
#include "settei.c"
#include "user.c"

BOOL InitApplication(HINSTANCE);
HWND InitInstance(HINSTANCE, int);


/************************************************************/
/*
	WinMain ֐
*/
/************************************************************/

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;
	HANDLE hAccel;
	HWND hwnd;

	hInst = hInstance;   //@CX^XnhO[oϐɃRs[

	if(!InitApplication(hInstance))
		return FALSE;

	if((hwnd=InitInstance(hInstance, nCmdShow)) == NULL)
		return FALSE;

	// \[XANZ[^[h@V[gJbgL[L
	hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDACCELERATOR));

	while( GetMessage(&msg,NULL,0,0) )
	{
		if( TranslateAccelerator(hWnd, hAccel, &msg) ) continue;
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return msg.wParam;
}



/************************************************************/
/*
	InitApplication ֐
*/
/************************************************************/

BOOL InitApplication(HINSTANCE hInstance)
{
	WNDCLASSEX wc;
	INITCOMMONCONTROLSEX iccex;

	//comctl32.dll̏iRRg[̏j 
	iccex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	iccex.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&iccex);	

	wc.cbSize        = sizeof(WNDCLASSEX);
	wc.style         = 0;
	wc.lpfnWndProc   = (WNDPROC)WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDICON));
	wc.hIconSm       = NULL;
	wc.hCursor       = LoadCursor( NULL,IDC_ARROW );
	wc.hbrBackground = (HBRUSH)(COLOR_BTNSHADOW);   // {^̔wiƓF
	wc.lpszMenuName  = MAKEINTRESOURCE(MAINMENU);
	wc.lpszClassName = THISNAME;

	return RegisterClassEx( &wc );
}



/************************************************************/
/*
	InitInstance ֐
*/
/************************************************************/

HWND InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	hWnd = CreateWindowEx(
			   WS_EX_ACCEPTFILES,   // hbOhbv󂯓
			   THISNAME,
			   TITLENAME,
			   WS_OVERLAPPEDWINDOW,
			   CW_USEDEFAULT,  CW_USEDEFAULT,
			   WINWIDTH,  WINHEIGHT,   // main.hŐݒ肵EBhETCY
			   HWND_DESKTOP,
			   NULL,
			   hInstance,
			   NULL);

	if(!hWnd)
		return NULL;

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return hWnd;
}



/************************************************************/
/*
	WndProc ֐@iCEBhẼvV[W֐j

	@[hX̃_CAO{bNX쐬AEBhE
	@`Ch(qEBhE)ƂĖߍł
*/
/************************************************************/

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wP, LPARAM lP)
{
	
	switch(msg){   // bZ[W

	case WM_CREATE:

		// _CAO(EBhEɔzu)쐬
		hDlg = CreateDialog((HINSTANCE)GetWindowLong(hwnd,GWL_HINSTANCE),
		                    MAKEINTRESOURCE(MAINDLG), hwnd,
							ModelessDlgProc);

		InitStatus(hwnd, hInst);      // Xe[^Xo[̏

		InitOption();      // ݒ̏P
		Init();            // ݒ̏Q

		SetTimer(hwnd, FIRSTTIMER, 35, NULL);   // ^C}[N
		break;

    case WM_TIMER:

		switch( LOWORD(wP) ){

		case FIRSTTIMER:
			KillTimer(hwnd, FIRSTTIMER);   // ^C}[~
			SetControlsPos(1);
			ShowWindow(hwnd, SW_SHOW);
			ShowWindow(hDlg, SW_SHOW);
			break;
		}
       break;

    case WM_DROPFILES:

		DropFiles(hDlg, wP);        // hbvt@C̏
		break;
	
	case WM_COMMAND:   // R}h

		// j[̏
		if( MenuCommands(msg, wP, lP) ) return TRUE;
		else                            return FALSE;

	case WM_SIZE:    // EChETCYύX

		SetControlsPos(1);   // {^ނ̈ʒu𒲐
		break;

	case WM_DESTROY:   // I

		EndOption();
		EndDialog(hDlg, IDOK);
		PostQuitMessage(0);
		break;

	default:

		return DefWindowProc(hwnd, msg, wP, lP);
	}
	return 0;
}



/************************************************************/
/*
	MenuCommands ֐ij[o[Ec[o[ɂR}hj
*/
/************************************************************/
 
int MenuCommands(UINT uMsg, WPARAM wP, LPARAM lP)
{
	HWND hFocus;   // tH[JXEBhẼnh
	int addnum=0;

	hFocus = GetFocus();

	switch(LOWORD(wP))
	{
	// ***** t@CJ *****
	case MENUOPEN:  

		if( GetOpenFileName(&ofn) )
			FileOpened(got_Filename, FROMCOMMON);
		break;

	// ***** IvV *****
	case MENUOPTION:

		InitPropSheet();   // vpeB[V[g쐬
		break;

	// ***** P`WԖڂ̃{^̃ANZ[^L[ꂽ *****
	case IDFUNC1:  case IDFUNC2:   case IDFUNC3:   case IDFUNC4:
	case IDFUNC5:  case IDFUNC6:   case IDFUNC7:   case IDFUNC8:

		ButtonPushed( LOWORD(wP) );
		break;

	// ***** I *****
	case MENUEXIT:

		SendMessage(hWnd, WM_CLOSE, 0, 0);
		return TRUE;

	}
	return FALSE;

}



/************************************************************/
/*
	ModelessDlgProc ֐@i_CAOvV[Wj
*/
/************************************************************/

BOOL CALLBACK ModelessDlgProc(HWND hdlg, UINT msg, WPARAM wP, LPARAM lP)
{
	switch(msg){

	case WM_INITDIALOG:   // 

		// t@CJR_CAȌ
		InitOpenFName(hdlg, got_Filename);
		break;

	case WM_RBUTTONDOWN:   // {^

//		***** ̃}EX{^ꂽƂ̏ɏ *****
		break;

	case WM_LBUTTONDOWN:   // E{^

//		***** Ẽ}EX{^ꂽƂ̏ɏ *****
		break;

	case WM_COMMAND:   // ȃR}h

		switch(LOWORD(wP)){

		// ***** P`WԖڂ̃{^ꂽ *****
		case IDFUNC1:  case IDFUNC2:   case IDFUNC3:   case IDFUNC4:
		case IDFUNC5:  case IDFUNC6:   case IDFUNC7:   case IDFUNC8:

			ButtonPushed( LOWORD(wP) );
			break;
		}

		break;
	}
	return FALSE;
}



/************************************************************/
/*
	OptionDlg1Proc ֐@iݒ1̃_CAOvV[Wj
*/
/************************************************************/

BOOL CALLBACK OptionDlg1Proc(HWND hdlg, UINT uMsg, WPARAM wP, LPARAM lP)
{
	int radio[3] = { 0, 0, 0 };

	NMHDR *nmhdr;

	switch(uMsg){

	case WM_INITDIALOG:
		// `FbN{bNX̕ݒ
		SetDlgItemText(hdlg, IDCHECK1, check1_Str);
		SetDlgItemText(hdlg, IDCHECK2, check2_Str);
		SetDlgItemText(hdlg, IDCHECK3, check3_Str);
		// *** ݒlǂݍŃEBhẼRg[ɔf
		SetChk(hdlg, IDCHECK1, settei1);
		SetChk(hdlg, IDCHECK2, settei2);
		SetChk(hdlg, IDCHECK3, settei3);
		break;

	case WM_NOTIFY:

		nmhdr = (NMHDR *)lP;

		switch(nmhdr->code){

        case PSN_APPLY:   // OKꂽ

			// *** Rg[̏Ԃ擾Ēlۑ
			settei1 = GetChk(hdlg, IDCHECK1);
			settei2 = GetChk(hdlg, IDCHECK2);
			settei3 = GetChk(hdlg, IDCHECK3);

			EndDialog(hdlg, TRUE);
			break;

        default:
            return FALSE;
        }
        break;

	default:
		return FALSE;
	}
	return TRUE;
}



/************************************************************/
/*
	InputDlgProc ֐@i̓_CAOvV[Wj
*/
/************************************************************/

LRESULT CALLBACK InputDlgProc(HWND hdlg, UINT uMsg, WPARAM wP, LPARAM lP)
{
	switch (uMsg){

	case WM_INITDIALOG:

		SetDlgItemText(hdlg, IDINPUTPROMPT, prompt_Str);
		SetDlgItemText(hdlg, IDINPUTBOX, input_Str);
		SetFocus( GetDlgItem(hdlg, IDINPUTBOX) );
		return FALSE;

	case WM_COMMAND:

		switch (LOWORD(wP)) {

		case IDOK:   // njꂽ
			GetDlgItemText(hdlg, IDINPUTBOX, input_Str, LINEBUF);
			IntNum = atoi(input_Str);
			DoubleNum = atof(input_Str);
			EndDialog(hdlg, IDOK);
			break;

		case IDCANCEL:   // b`mbdkA邪ꂽ
			EndDialog(hdlg, IDCANCEL);
			sprintf(input_Str, "");
			IntNum = -1;
			DoubleNum = -1.0;
			break;

		default:
			return FALSE;
		}

	default:
		return FALSE;

	}
	return TRUE;
}
