/*////////////////////////////////////////////////////////////

 settei.c t@C

////////////////////////////////////////////////////////////*/



/************************************************************/
/*
	Printf ֐itw肵Rg[ɓ͂j
*/
/************************************************************/

void Printf(int control, const char *p_str, ... )
{
    va_list Vlist;
    char *tmp_str;
	int i;

	// 󂯎obt@m
	tmp_str = GlobalAlloc(GMEM_FIXED, sizeof(char) * DISPBUF);

    va_start(Vlist, p_str);
	vsprintf(tmp_str, p_str, Vlist);   // tmp_str obt@ɏo
    va_end(Vlist);

	// o͐̃Rg[I
	switch(control){

	case DISP:   // \̈ DISP
		strcat(disp_Str, tmp_str);
		SetDlgItemText(hDlg, IDDISP, disp_Str);   // o
		break;

	case STATUS1:   // Xe[^Xo[Pij
		SendMessage(hStatus, SB_SETTEXT, 0, (LPARAM)tmp_str);   // o
		break;

	case STATUS2:   // Xe[^Xo[QiEj
		SendMessage(hStatus, SB_SETTEXT, 1, (LPARAM)tmp_str);   // o
		break;

	case MESSAGE:   // bZ[W{bNX
		strcpy(msg_Str, tmp_str);
		MessageBox(hDlg, msg_Str, " ", MB_OK);   // o
		break;

	case TITLEBAR:   // ^Cgo[
		SetWindowText(hWnd, tmp_str);
		break;

	// {^
	case BUTTON1: case BUTTON2: case BUTTON3: case BUTTON4:
	case BUTTON5: case BUTTON6: case BUTTON7: case BUTTON8:
		
		for(i=0; i<MAXBUTTON; i++){
			if(pow(2, i) == (int)(control/BUTTON1)){
				SetDlgItemText(hDlg, IDFUNC1+i, tmp_str);
				break;
			}
		}
		break;
	}

	GlobalFree(tmp_str);
}




/************************************************************/
/*
	Gettext ֐iRg[ɕ\Ă镶𓾂j
*/
/************************************************************/

void Gettext(int control, char *gotstr)
{
    char *tmp_str;
	int i;

	// 󂯎obt@m
	tmp_str = GlobalAlloc(GMEM_FIXED, sizeof(char) * LINEBUF);

	// Rg[I
	switch(control){

	case STATUS1:   // Xe[^Xo[P
		SendMessage(hStatus, SB_GETTEXT, 0, (LPARAM)tmp_str);   // 
		break;

	case STATUS2:   // Xe[^Xo[Q
		SendMessage(hStatus, SB_GETTEXT, 0, (LPARAM)tmp_str);   // 
		break;

	case TITLEBAR:   // ^Cgo[
		GetWindowText(hWnd, tmp_str, LINEBUF);
		break;

	case BUTTON1: case BUTTON2: case BUTTON3: case BUTTON4:   // {^
	case BUTTON5: case BUTTON6: case BUTTON7: case BUTTON8:

		for(i=0; i<MAXBUTTON; i++){
			if(pow(2, i) == (int)(control/BUTTON1)){
				GetDlgItemText(hDlg, IDFUNC1+i, gotstr, LINEBUF);
				break;
			}
		}
		break;
	}

	GlobalFree(tmp_str);
}



/************************************************************/
/*
	Open ֐iR_CAOŃt@CJ@ۂ
	t@C𓾂邾j
*/
/************************************************************/

int Open(char *filepath, char *fname)
{
	ofn.lpstrTitle = "J";

	ofn.lpstrInitialDir = filepath;

	// t@CJR_CAOo
	if( GetOpenFileName(&ofn) ){
		sprintf(fname, "%s", got_Filename);
		return NOERR;
	}
	return ERR;
}



/************************************************************/
/*
	Save ֐iR_CAOJAOtt@C
	obt@̕oj
*/
/************************************************************/

int Save(const char *filepath, char *buf, long bufsize)
{
	int i;
	FILE *f_stream;

	// Z[ut@C̃tH[}bg
	ofn.lpstrFilter = "eLXgt@C(*.txt)\0*.txt\0SẴt@C(*.*)\0*.*\0\0";

	ofn.lpstrTitle = "ۑ";

	ofn.lpstrInitialDir = filepath;   // ftHgŊJtH_ݒ

	if( GetSaveFileName(&ofn) )   // t@CR_CAOŎ󂯎
	{
		if((f_stream=fopen(got_Filename, "wb")) == NULL){
			sprintf(temp_Str, "t@C\r\n\"%s\"ۑł܂B", got_Filename);
			MessageBox(hDlg, (LPCTSTR)temp_Str, "G[", MB_ICONEXCLAMATION | MB_OK);
			return ERR;   // t@CJȂG[
		}
		for(i=0; i<bufsize && i<FILEBUF; i++)
			fputc( *(buf++), f_stream);   // Pó@'\0'o͂邽߂
		                                  // @ɂĂ邪AƂ@͂Ȃ

		fclose(f_stream);   // t@C
		return NOERR;
	}

	return ERR;
}



/************************************************************/
/*
	Inputtext ֐i͂̃_CAOoA{bNX
	͂ꂽ𕶎Ƃēj
*/
/************************************************************/

void Inputtext(char *gotstr, const char *promptstr, const char *defaultstr)
{
	// vvg̕O[oϐɃRs[
	sprintf(prompt_Str, "%s", promptstr);
	// ͕̃ftHgO[oϐɃRs[
	sprintf(input_Str, "%s", defaultstr);

	DialogBox( hInst, "INPUTDLG", hDlg, (DLGPROC)InputDlgProc);

	sprintf(gotstr, "%s", input_Str);   // ͂ꂽ𓾂
}



/************************************************************/
/*
	Inputint ֐i͂̃_CAOoA{bNX
	͂ꂽ𐮐l(int)Ƃēj
*/
/************************************************************/

int Inputint(const char *promptstr, const char *defaultstr)
{
	// vvg̕O[oϐɃRs[
	sprintf(prompt_Str, "%s", promptstr);
	// ͕̃ftHgO[oϐɃRs[
	sprintf(input_Str, "%s", defaultstr);

	DialogBox( hInst, "INPUTDLG", hDlg, (DLGPROC)InputDlgProc);

	return IntNum;
}



/************************************************************/
/*
	Inputdouble ֐i͂̃_CAOoA{bNX
	͂ꂽl(double)Ƃēj
*/
/************************************************************/

double Inputdouble(const char *promptstr, const char *defaultstr)
{
	// vvg̕O[oϐɃRs[
	sprintf(prompt_Str, "%s", promptstr);

	// ͕̃ftHgO[oϐɃRs[
	sprintf(input_Str, "%s", defaultstr);

	DialogBox( hInst, "INPUTDLG", hDlg, (DLGPROC)InputDlgProc);

	return DoubleNum;
}



/************************************************************/
/*
	Clear ֐iwӏɕ\ꂽj
*/
/************************************************************/

void Clear(int control)
{
	int i;

	if(control & DISP){   // \̈
		disp_Str[0]='\0';
		Printf(DISP, "");
	}
	if(control & STATUS1)   // Xe[^Xo[Pij
		Printf(STATUS1, "");

	if(control & STATUS2)   // Xe[^Xo[QiEj
		Printf(STATUS2, "");

	if(control & TITLEBAR)   // ^Cgo[
		Printf(TITLEBAR, "");

	for(i=0; i<MAXBUTTON; i++){   // {^
		if(control & (int)pow(2, i)*BUTTON1)
			Printf((int)pow(2, i)*BUTTON1, "");
	}
}



/************************************************************/
/*
	EndOption ֐iIj
*/
/************************************************************/

void EndOption()
{
	// 
	free(temp_Str);
	free(msg_Str);
	free(disp_Str);
	free(prompt_Str);
	free(input_Str);
}


/************************************************************/
/*
	DropFiles ֐ihbvꂽt@C̏j
*/
/************************************************************/

void DropFiles(HWND hDlg, WPARAM wp)
{
	HDROP hDrop;
	UINT uFileNo;
	int hfile;

	SetForegroundWindow(hWnd);   // EChEANeBu

	hDrop = (HDROP)wp;
	uFileNo = DragQueryFile((HDROP)wp, 0xFFFFFFFF, NULL, 0);

	// hbvꂽt@C̖O𓾂
	DragQueryFile(hDrop, 0, got_Filename, sizeof(got_Filename));

	DragFinish(hDrop);   // hbOI

	// t@CȂJ
	if((hfile=_open(got_Filename, _O_RDONLY)) != -1){
		_close(hfile);
		FileOpened(got_Filename, FROMDRAGDROP);
	}
}



/************************************************************/
/*
	SetControlsPos ֐iRg[̈ʒuE傫ύXj
*/
/************************************************************/

void SetControlsPos(int resizeok)
{
	HWND hTarget;
	RECT rc, drc, src;
	static int ww, wh, dww, dwh, swh, sww[2];
	static int isfirst=2;
	int i, no=USEBUTTON+1;
	int moveflg, sizeflg;

	// Rg[
	int idTarget[] = { IDDISP, IDFUNC1, IDFUNC2, IDFUNC3, IDFUNC4,
	                           IDFUNC5, IDFUNC6, IDFUNC7, IDFUNC8 };
	static int
		left[]    = { 10, 10, 130, 250, 370, 10, 130, 250, 370 } ,
		top[]     = { 10, -140, -140, -140, -140, -100, -100, -100, -100 } ,
		width[]   = { -30, 0, 0, 0, 0, 0, 0, 0, 0 } ,
		height[]  = { -160, 0, 0, 0, 0, 0, 0, 0, 0 } ;

	int t_left, t_top, t_width, t_height;

	GetWindowRect(hWnd, &rc);   // CEBhȆ傫擾
	GetWindowRect(hDlg, &drc);   // _CAȎ傫擾
	GetWindowRect(hStatus, &src);   // Xe[^Xo[̑傫擾

	ww=rc.right-rc.left;   wh=rc.bottom-rc.top;
	dww=drc.right-drc.left;   dwh=drc.bottom-drc.top;
	swh=src.bottom-src.top;

	if(isfirst || ww>65536 || wh>65536 || dww>65536 || dwh>65536 || (signed)ww<0 || (signed)wh<0){
		if(isfirst>0) isfirst--;
		ww=WINWIDTH;   wh=WINHEIGHT;
	}
	if(ww>10){
		sww[0]=ww-STATUSWIDTH;  sww[1]=ww;
		SendMessage(hStatus, SB_SETPARTS, (WPARAM)2, (LPARAM)(LPINT)sww);
		SendMessage(hStatus, WM_SIZE, 0, MAKELONG(ww,16));
	}
	SetWindowPos(hDlg, HWND_TOP, 0, 0, ww, rc.bottom-drc.top-swh-8, SWP_NOMOVE);

	// xȏ̓_CAO傫()ȂȂ
	if(ww > 1600)          ww=1600;
	if(wh < WINHEIGHT-140) wh=WINHEIGHT-140;
	if(wh > 1200)          wh=1200;

	wh-=swh+(swh-26)*2;  // "fUC"ŕ\ʒu̒

	for(i=0; i<no && resizeok; i++)
	{
		t_left=left[i];   
		// {^SȉTȏォɂă{^̈ʒuς
		if(i) t_top=top[i]+(int)(1-(USEBUTTON-1)/4)*40;
		else  t_top=top[i];
		t_width=width[i];
		// {^SȉTȏォɂDISP̍ς
		if(i) t_height=height[i];
		else  t_height=height[i]+(int)(1-(USEBUTTON-1)/4)*40; 
		moveflg=0;  sizeflg=0;
		if(t_left || t_top)     moveflg=1;
		if(t_width || t_height) sizeflg=1;
		if(t_left<0)   t_left+=ww;     // ʒu
		if(t_top<0)    t_top+=wh;      // ʒu
		if(t_width<0)  t_width+=ww;    // 
		if(t_height<0) t_height+=wh;   // 

		hTarget = GetDlgItem(hDlg, idTarget[i]);

		if(moveflg){
			SetWindowPos(hTarget,HWND_TOP, t_left, t_top, 0, 0, SWP_NOSIZE);
			ReloadWindow(hTarget);
		}
		if(sizeflg){
			SetWindowPos(hTarget,HWND_TOP, 0, 0, t_width, t_height, SWP_NOMOVE);
			ReloadWindow(hTarget);
		}
	}
}
